Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| Eclipse Platform Release 3.0
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.eclipse.swt.custom
Class ScrolledComposite

    java.lang.Object
      org.eclipse.swt.widgets.Widget
          org.eclipse.swt.widgets.Control
              org.eclipse.swt.widgets.Scrollable
                  org.eclipse.swt.widgets.Composite
                      org.eclipse.swt.custom.ScrolledComposite

All Implemented Interfaces:
  Drawable

Direct Known Subclasses:
  SharedScrolledComposite

public class ScrolledComposite
extends Composite

A ScrolledComposite provides scrollbars and will scroll its content when the user uses the scrollbars.

There are two ways to use the ScrolledComposite:

1) Set the size of the control that is being scrolled and the ScrolledComposite will show scrollbars when the contained control can not be fully seen. 2) The second way imitates the way a browser would work. Set the minimum size of the control and the ScrolledComposite will show scroll bars if the visible area is less than the minimum size of the control and it will expand the size of the control if the visible area is greater than the minimum size. This requires invoking both setMinWidth(), setMinHeight() and setExpandHorizontal(), setExpandVertical(). ``

     public static void main (String [] args) {
          Display display = new Display ();
          Color red = display.getSystemColor(SWT.COLOR_RED);
          Color blue = display.getSystemColor(SWT.COLOR_BLUE);
          Shell shell = new Shell (display);
          shell.setLayout(new FillLayout());

          // set the size of the scrolled content - method 1
          final ScrolledComposite sc1 = new ScrolledComposite(shell, SWT.H_SCROLL | SWT.V_SCROLL | SWT.BORDER);
          final Composite c1 = new Composite(sc1, SWT.NONE);
          sc1.setContent(c1);
          c1.setBackground(red);
          GridLayout layout = new GridLayout();
          layout.numColumns = 4;
          c1.setLayout(layout);
          Button b1 = new Button (c1, SWT.PUSH);
          b1.setText("first button");
          c1.setSize(c1.computeSize(SWT.DEFAULT, SWT.DEFAULT));

          // set the minimum width and height of the scrolled content - method 2
          final ScrolledComposite sc2 = new ScrolledComposite(shell, SWT.H_SCROLL | SWT.V_SCROLL | SWT.BORDER);
          sc2.setExpandHorizontal(true);
          sc2.setExpandVertical(true);
          final Composite c2 = new Composite(sc2, SWT.NONE);
          sc2.setContent(c2);
          c2.setBackground(blue);
          layout = new GridLayout();
          layout.numColumns = 4;
          c2.setLayout(layout);
          Button b2 = new Button (c2, SWT.PUSH);
          b2.setText("first button");
          sc2.setMinSize(c2.computeSize(SWT.DEFAULT, SWT.DEFAULT));

          Button add = new Button (shell, SWT.PUSH);
          add.setText("add children");
          final int[] index = new int[]{0};
          add.addListener(SWT.Selection, new Listener() {
              public void handleEvent(Event e) {
                  index[0]++;
                  Button button = new Button(c1, SWT.PUSH);
                  button.setText("button "+index[0]);
                  // reset size of content so children can be seen - method 1
                  c1.setSize(c1.computeSize(SWT.DEFAULT, SWT.DEFAULT));
                  c1.layout();

                  button = new Button(c2, SWT.PUSH);
                  button.setText("button "+index[0]);
                  // reset the minimum width and height so children can be seen - method 2
                  sc2.setMinSize(c2.computeSize(SWT.DEFAULT, SWT.DEFAULT));
                  c2.layout();
              }
          });

          shell.open ();
          while (!shell.isDisposed ()) {
              if (!display.readAndDispatch ()) display.sleep ();
          }
          display.dispose ();
     }

Styles:
  H_SCROLL, V_SCROLL

Field Summary

Fields inherited from class org.eclipse.swt.widgets.Control
`handle`

Constructor Summary
`ScrolledComposite(Composite parent, int style)` Constructs a new instance of this class given its parent and a style value describing its behavior and appearance.

Method Summary
`Point` | `computeSize(int wHint, int hHint, boolean changed)` Returns the preferred size of the receiver.
`boolean` | `getAlwaysShowScrollBars()` Returns the Always Show Scrollbars flag.
`Control` | `getContent()` Get the content that is being scrolled.
`Point` | `getOrigin()` Return the point in the content that currenly appears in the top left corner of the scrolled composite.
`void` | `layout(boolean changed)` If the receiver has a layout, asks the layout to lay out (that is, set the size and location of) the receiver's children.
`void` | `setAlwaysShowScrollBars(boolean show)` Set the Always Show Scrollbars flag.
`void` | `setContent(Control content)` Set the content that will be scrolled.
`void` | `setExpandHorizontal(boolean expand)` Configure the ScrolledComposite to resize the content object to be as wide as the ScrolledComposite when the width of the ScrolledComposite is greater than the minimum width specified in setMinWidth.
`void` | `setExpandVertical(boolean expand)` Configure the ScrolledComposite to resize the content object to be as tall as the ScrolledComposite when the height of the ScrolledComposite is greater than the minimum height specified in setMinHeight.
`void` | `setLayout(Layout layout)` Sets the layout which is associated with the receiver to be the argument which may be null.
`void` | `setMinHeight(int height)` Specify the minimum height at which the ScrolledComposite will begin scrolling the content with the vertical scroll bar.
`void` | `setMinSize(int width, int height)` Specify the minimum width and height at which the ScrolledComposite will begin scrolling the content with the horizontal scroll bar.
`void` | `setMinSize(Point size)` Specify the minimum width and height at which the ScrolledComposite will begin scrolling the content with the horizontal scroll bar.
`void` | `setMinWidth(int width)` Specify the minimum width at which the ScrolledComposite will begin scrolling the content with the horizontal scroll bar.
`void` | `setOrigin(int x, int y)` Scrolls the content so that the specified point in the content is in the top left corner.
`void` | `setOrigin(Point origin)` Scrolls the content so that the specified point in the content is in the top left corner.

Methods inherited from class org.eclipse.swt.widgets.Composite
`checkSubclass, getChildren, getLayout, getTabList, layout, setFocus, setTabList`

Methods inherited from class org.eclipse.swt.widgets.Scrollable
`computeTrim, getClientArea, getHorizontalBar, getVerticalBar`

Methods inherited from class org.eclipse.swt.widgets.Control
`addControlListener, addFocusListener, addHelpListener, addKeyListener, addMouseListener, addMouseMoveListener, addMouseTrackListener, addPaintListener, addTraverseListener, computeSize, forceFocus, getAccessible, getBackground, getBorderWidth, getBounds, getEnabled, getFont, getForeground, getLayoutData, getLocation, getMenu, getMonitor, getParent, getShell, getSize, getToolTipText, getVisible, internal_dispose_GC, internal_new_GC, isEnabled, isFocusControl, isReparentable, isVisible, moveAbove, moveBelow, pack, pack, redraw, redraw, removeControlListener, removeFocusListener, removeHelpListener, removeKeyListener, removeMouseListener, removeMouseMoveListener, removeMouseTrackListener, removePaintListener, removeTraverseListener, setBackground, setBounds, setBounds, setCapture, setCursor, setEnabled, setFont, setForeground, setLayoutData, setLocation, setLocation, setMenu, setParent, setRedraw, setSize, setSize, setToolTipText, setVisible, toControl, toControl, toDisplay, toDisplay, traverse, update`

Methods inherited from class org.eclipse.swt.widgets.Widget
`addDisposeListener, addListener, checkWidget, dispose, getData, getData, getDisplay, getStyle, isDisposed, isListening, notifyListeners, removeDisposeListener, removeListener, removeListener, setData, setData, toString`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Constructor Detail

### ScrolledComposite

    public ScrolledComposite(Composite parent,
                             int style)

  Constructs a new instance of this class given its parent and a style value describing its behavior and appearance.

  The style value is either one of the style constants defined in class `SWT` which is applicable to instances of this class, or must be built by bitwise OR'ing together (that is, using the `int` "|" operator) two or more of those `SWT` style constants. The class description lists the style constants that are applicable to the class. Style bits are also inherited from superclasses.

Parameters:
  `parent` - a widget which will be the parent of the new instance (cannot be null)
  `style` - the style of widget to construct
Throws:
  `IllegalArgumentException` -
  - ERROR_NULL_ARGUMENT - if the parent is null
  `SWTException` -
  - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the parent
See Also:
  `SWT.H_SCROLL`, `SWT.V_SCROLL`, `Widget.getStyle()`

Method Detail

### computeSize

    public Point computeSize(int wHint,
                             int hHint,
                             boolean changed)

  Description copied from class: `Control`
  Returns the preferred size of the receiver.

  The preferred size of a control is the size that it would best be displayed at. The width hint and height hint arguments allow the caller to ask a control questions such as "Given a particular width, how high does the control need to be to show all of the contents?" To indicate that the caller does not wish to constrain a particular dimension, the constant `SWT.DEFAULT` is passed for the hint.

  If the changed flag is `true`, it indicates that the receiver's contents have changed, therefore any caches that a layout manager containing the control may have been keeping need to be flushed. When the control is resized, the changed flag will be `false`, so layout manager caches can be retained.

  Overrides:
    `computeSize` in class `Composite`

### getAlwaysShowScrollBars

    public boolean getAlwaysShowScrollBars()

  Returns the Always Show Scrollbars flag. True if the scrollbars are always shown even if they are not required. False if the scrollbars are only visible when some part of the composite needs to be scrolled to be seen. The H_SCROLL and V_SCROLL style bits are also required to enable scrollbars in the horizontal and vertical directions.

  Returns:
    the Always Show Scrollbars flag value

### getContent

    public Control getContent()

  Get the content that is being scrolled.

  Returns:
    the control displayed in the content area

### layout

    public void layout(boolean changed)

  Description copied from class: `Composite`
  If the receiver has a layout, asks the layout to lay out (that is, set the size and location of) the receiver's children. If the the argument is `true` the layout must not rely on any cached information it is keeping about the children. If it is `false` the layout may (potentially) simplify the work it is doing by assuming that the state of the none of the receiver's children has changed since the last layout. If the receiver does not have a layout, do nothing.

  Overrides:
    `layout` in class `Composite`
  Parameters:
    `changed` - `true` if the layout must flush its caches, and `false` otherwise

### getOrigin

    public Point getOrigin()

  Return the point in the content that currenly appears in the top left corner of the scrolled composite.

  Returns:
    the point in the content that currenly appears in the top left corner of the scrolled composite. If no content has been set, this returns (0, 0).
  Throws:
    `SWTException` -
    - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
    - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver
  Since:
    2.0

### setOrigin

    public void setOrigin(Point origin)

  Scrolls the content so that the specified point in the content is in the top left corner. If no content has been set, nothing will occur. Negative values will be ignored. Values greater than the maximum scroll distance will result in scrolling to the end of the scrollbar.

  Parameters:
    `origin` - the point on the content to appear in the top left corner
  Throws:
    `SWTException` -
    - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
    - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver
    - ERROR_INVALID_ARGUMENT - value of origin is outside of content
  Since:
    2.0

### setOrigin

    public void setOrigin(int x,
                          int y)

  Scrolls the content so that the specified point in the content is in the top left corner. If no content has been set, nothing will occur. Negative values will be ignored. Values greater than the maximum scroll distance will result in scrolling to the end of the scrollbar.

  Parameters:
    `x` - the x coordinate of the content to appear in the top left corner
    `y` - the y coordinate of the content to appear in the top left corner
  Throws:
    `SWTException` -
    - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
    - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver
  Since:
    2.0

### setAlwaysShowScrollBars

    public void setAlwaysShowScrollBars(boolean show)

  Set the Always Show Scrollbars flag. True if the scrollbars are always shown even if they are not required. False if the scrollbars are only visible when some part of the composite needs to be scrolled to be seen. The H_SCROLL and V_SCROLL style bits are also required to enable scrollbars in the horizontal and vertical directions.

  Parameters:
    `show` - true to show the scrollbars even when not required, false to show scrollbars only when required
  Throws:
    `SWTException` -
    - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
    - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver

### setContent

    public void setContent(Control content)

  Set the content that will be scrolled.

  Parameters:
    `content` - the control to be displayed in the content area
  Throws:
    `SWTException` -
    - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
    - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver

### setExpandHorizontal

    public void setExpandHorizontal(boolean expand)

  Configure the ScrolledComposite to resize the content object to be as wide as the ScrolledComposite when the width of the ScrolledComposite is greater than the minimum width specified in setMinWidth. If the ScrolledComposite is less than the minimum width, the content will not resized and instead the horizontal scroll bar will be used to view the entire width. If expand is false, this behaviour is turned off. By default, this behaviour is turned off.

  Parameters:
    `expand` - true to expand the content control to fill available horizontal space
  Throws:
    `SWTException` -
    - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
    - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver

### setExpandVertical

    public void setExpandVertical(boolean expand)

  Configure the ScrolledComposite to resize the content object to be as tall as the ScrolledComposite when the height of the ScrolledComposite is greater than the minimum height specified in setMinHeight. If the ScrolledComposite is less than the minimum height, the content will not resized and instead the vertical scroll bar will be used to view the entire height. If expand is false, this behaviour is turned off. By default, this behaviour is turned off.

  Parameters:
    `expand` - true to expand the content control to fill available vertical space
  Throws:
    `SWTException` -
    - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
    - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver

### setLayout

    public void setLayout(Layout layout)

  Description copied from class: `Composite`
  Sets the layout which is associated with the receiver to be the argument which may be null.

  Overrides:
    `setLayout` in class `Composite`
  Parameters:
    `layout` - the receiver's new layout or null

### setMinHeight

    public void setMinHeight(int height)

  Specify the minimum height at which the ScrolledComposite will begin scrolling the content with the vertical scroll bar. This value is only relevant if setExpandVertical(true) has been set.

  Parameters:
    `height` - the minimum height or 0 for default height
  Throws:
    `SWTException` -
    - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
    - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver

### setMinSize

    public void setMinSize(Point size)

  Specify the minimum width and height at which the ScrolledComposite will begin scrolling the content with the horizontal scroll bar. This value is only relevant if setExpandHorizontal(true) and setExpandVertical(true) have been set.

  Parameters:
    `size` - the minimum size or null for the default size
  Throws:
    `SWTException` -
    - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
    - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver

### setMinSize

    public void setMinSize(int width,
                           int height)

  Specify the minimum width and height at which the ScrolledComposite will begin scrolling the content with the horizontal scroll bar. This value is only relevant if setExpandHorizontal(true) and setExpandVertical(true) have been set.

  Parameters:
    `width` - the minimum width or 0 for default width
    `height` - the minimum height or 0 for default height
  Throws:
    `SWTException` -
    - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
    - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver

### setMinWidth

    public void setMinWidth(int width)

  Specify the minimum width at which the ScrolledComposite will begin scrolling the content with the horizontal scroll bar. This value is only relevant if setExpandHorizontal(true) has been set.

  Parameters:
    `width` - the minimum width or 0 for default width
  Throws:
    `SWTException` -
    - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
    - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| Eclipse Platform Release 3.0
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Guidelines for using Eclipse APIs.

Copyright (c) IBM Corp. and others 2000, 2004. All rights reserved.